 // filename <W0EB_W2CTX_NANO_EEPROM_Initializer.ino>
 // Jim Giammanco, N5IB
 // 9 March 2018

 //EEPROM addresses (decimal, then hex in comment) for RadI2Cino stored parameters
#define MASTER_CAL   0  //hex00 calibration   (int32_t)
#define LSB_CAL      4  //hex04
#define USB_CAL      8  //hex08 usbCarrier   (unsigned long)
#define SIDE_TONE   12  //hex0C
#define VFO_A       16  //hex10 vfoA   (unsigned long)
#define VFO_B       20  //hex14 vfoB   (unsigned long)
#define CW_SIDETONE 24  //hex18 sideTone   (unsigned long)
#define CW_SPEED    28  //hex1C wpm   (integer)
#define FREQ_INCR   32  //hex20 Freq_Index   (integer)
#define KEY_TYPE    36  //hex24
#define MODE        40  //hex28 ubitx_mode   (integer)
//note 6 byte interval follows, rather than 4 bytes
#define VOLTS       46  //hex2E Volts_Active   (boolean)
#define BAUD        50  //hex32 ubitx_baud   (integer)
#define XTALPF      54  //hex36 SI5351BX_XTALPF   (unsigned integer)
#define IAMBIC_MODE 58  //hex 3A  
#define PDL_SWAP_VAL 62 //hex 3E  

#include <EEPROM.h>

unsigned int ui; // some varaibles types to hold EEPROM.get results
boolean boo;
int ii;
int32_t i32t;
float ff;
unsigned long ll;
byte by;

int EEsize = 1024; // size in bytes of your board's EEPROM
int startAdr = 0x00;
int endAdr = 0x3F;
byte initPROM[66]=       //bytes to pre-load the RadI2Cino EEPROM
  {0xD2,0xDD,0xFF,0xFF   // addr 0: MASTER_CAL   -8750
  ,0x00,0x00,0x00,0x00   // addr 4:LSB_CAL  0
  ,0xB2,0x0E,0xB7,0x00   // addr 8:USB_CAL  11996850
  ,0x00,0x00,0x00,0x00   // addr 12: SIDE_TONE  0
  ,0x10,0x93,0x6B,0x00   // addr 16: VFO_A  7050000
  ,0xC8,0x09,0x6F,0x00   // addr 20: VFO_B  7277000
  ,0x00,0x00,0x00,0x00   // addr 24: CW_SIDETONE  0
  ,0x0E,0x00,0x00,0x00   // addr 28: CW_SPEED  14
  ,0x01,0x00,0x00,0x00   // addr 32: FREQ_INC   1
  ,0x00,0x00,0x00,0x00   // addr 36: KEY_TYPE   0
  ,0x00,0x00,0x00,0x00   // addr 40: MODE  2
  ,0x00,0x00             // addr 44: not used  0
  ,0x00,0x00,0x00,0x00   // addr 46: VOLTS  0
  ,0x03,0x00,0x00,0x00   // addr 50: BAUD  3
  ,0x03,0x00,0x00,0x00   // addr 54: XTALPF 3  
  ,0x00,0x00,0x00,0x00   // addr 58: IAMBIC_MODE  0
  ,0x00,0x00,0x00,0x00};   // addr 62: PDL_SWAP_VAL  0
  
void setup()
{
  Serial.begin(9600);
}

void loop()
{
  Serial.println("Writing array to EEPROM");
  Serial.println();
    
  for(int a=0; a<65; a++) {
    EEPROM.write(a,initPROM[a]);
    Serial.print("#");
  }
  Serial.println();
  Serial.println("FINISHED");
  while(1) {
    }
}
